#!/bin/sh

echo
echo "       -=- ejabberd post installation script -=- "
echo "              (c) 2005-2017 ProcessOne "

ROOT_DIR="@@INSTALLDIR@@"
HOME_DIR="$(echo $ROOT_DIR | sed 's/ejabberd-.*/ejabberd/')"
CTL="$ROOT_DIR/bin/ejabberdctl"
echo 
[ $(id -u) -eq 0 ] && {
  echo "* Setting ejabberd account"
  useradd -rU ejabberd 2>/dev/null
  owner=$(id -u ejabberd):$(id -g ejabberd 2>/dev/null || echo 0)
  sed -i -e "s/INSTALLUSER=\"root\"/INSTALLUSER=\"ejabberd\"/" "$ROOT_DIR"/bin/ejabberdctl
  [ -d /etc/init.d ] && {
    echo "copy init script in /etc/init.d/ejabberd"
    cp "$ROOT_DIR"/bin/ejabberd.init /etc/init.d/ejabberd
  }
  for dir in database conf logs
  do
    [ -d "$HOME_DIR"/$dir ] || mkdir -p "$HOME_DIR"/$dir
  done
  echo 
  [ -e "$HOME_DIR"/conf/ejabberd.yml ] && {
    echo "* Use existing ejabberd configuration"
  } || {
    echo "* Apply new ejabberd configuration"
    cp "$ROOT_DIR"/conf/* "$HOME_DIR"/conf
  }
  echo "configuration in $HOME_DIR/conf/ejabberd.yml"
  chown -R $owner "$ROOT_DIR" "$HOME_DIR"
  usermod -d "$HOME_DIR" ejabberd
}
echo 
echo "* Starting ejabberd instance"
"$CTL" start
"$CTL" started
[ $? -eq 0 ] && {
  echo
  echo "* Creating administrator user"
  "$CTL" register "$1" "$2" "$3"
  echo
  echo "* Stopping ejabberd instance"
  "$CTL" stop
  "$CTL" stopped
  echo "==> Setup finished"
} || {
  echo "* WARNING ! ejabberd can not start"
  echo "Admin user is not created"
  echo "Please check your configuration"
}
